---
title: "New version of the website! 📓"
description: "New website version with hugo framework"
date: 2022-04-12
summary: "New website version with hugo framework"
categories: ["posts", "hugo", "CI/CD"]
---
## Good old CMS 💾
One of the most popular software for making websites is WordPress, its advantages are its accessibility and its many plugins.  

WordPress is called a CMS (content management system) and contains an interface to administer the website, modify content and create users and manage their rights...  
For a big website with many contributors it can be a good solution, especially that the embedded editor is intuitive to use.  

But it comes with drawbacks, the software stack needs a database and the pages are generated by the server.  
This last point is very important because it made the page loading much slower and the server load heavier.  

Because the content is not static it cannot be cached as well as static files.  
This is why I tried a new solution to make my website based on static website generation frameworks.  

## Push, Build, Deploy 🚀
This new way of making websites is closely related to the recent trends of PaaS and CI/CD.  

The idea behind these frameworks (I used [Hugo](https://gohugo.io)) is to configure parameters files (json, yaml, toml), create templates and manage the routes of your website as folders and pages as markdown files.  

The framework can then build the static html files of your website from these files.  
You can understand that with this workflow, these frameworks are clearly made for developers and it's not over...  

The advantage behind this workflow is that you can add CI/CD jobs to build and deploy your website automatically.  

CI/CD jobs are tasks that will be automatically triggered according to conditions you configure relatives of the activity of your repository.  

These tasks clone your repository and do work independently of your machine, so you can run tests as well as build and deploy software while your machine is on standby and you drink your coffee (or tea).  

This is what I personally set up and each time I pushed to the main branch of the website repository, a job automatically build and deploy the website.  

To finish the fact that your website is static do not only make it really fast but also makes it cheap to host.  

This makes that you can find a lot of PaaS services (like Heroku, Netlify or even GitHub/GitLab pages) to host your website for free!  
Personally, I prefer hosting this website by the amazing Coincoin Web Services. 😁  

## Look at the code! 🤓
[@coincoingit repo](https://coincoingit.fr/flavien/Hugo-portfolio "Coincoingit: un coincoin pour votre code").