---
title: "☁️ Self-hosted Coincoin Web Services"
description: "The best Web Services of the all internet."
date: 2022-01-02
summary: "The best Web Services of the all internet."
categories: ["projects", "cloud", "sysadmin"]
---
## Why bother to do that ? 🤔
For a long time, I wanted to have my own cloud ☁️ to play and learn sysadmin and be independent of too much centralized services.  

I also use the server as remote development machine, the server is much faster than machines of my school and all containerized development avoid the "it works on my machine" problems...  

So I built my own Nextcloud based cloud, a mail stack and a Gitea.  
I use an LDAP directory to link Nextcloud, Gitea and mail in one account.  

For development I use the great feature of VS code "remote devcontainer" that let you develop with VS code within remote containerized environments.  

![screenshot](img/Capture_Coincoincloud.png)
![screenshot](img/Capture_Coincoinmail.png)
![screenshot](img/Capture_Coincoingit.png)

## My home lab 📡
The infrastructure is self hosted on my personal servers (HPE micro-server gen10+, raspberry pi 4) and all my services are containerized and orchestrated with Docker Swarm.  

It uses Traefik as a proxy to manage all the routes to subdomains and their certificates. When connected to the docker engine this proxy is very easy to manage.  

I monitor my infrastructure with Grafana who gets metrics from Prometheus and Traefik as well as logs from all the containers with Loki.  

Alerts from the raspberry pi and some cloud services are configured to warn me in case of hardware or system problems on my server as well as if my websites are down.  

The server is configured for high availability with 2 redundant raid 1 bootable root partition / data partition.  

All the important data are regularly backed up on cloud storage so my apartment can burn 🔥 without losing any data.  

![screenshot](img/Capture_Traefik.png)
![screenshot](img/Capture_Grafana_Stats.png)
![screenshot](img/Capture_Grafana_Probes.png)
![screenshot](img/Capture_Prometheus.png)

## What's next ? 🔮
I recently installed Drone CI to get continuous integration service with my Gitea and now I discovered Harbor, a container registry service.  

I would like to deploy it on my stack, there is no configuration for a docker swarm deployment so this will be a good exercise.  

_PS: If you want a coincoincloud account with an @coincoinmail.fr address and a coincoingit access send me a request by mail!_  
